//->colpal


int colpal_handle;
int colpal_thandle;
int colpal_palette;
int colpal_currnum;
int colpal_centre;
int colpal_file;
int colpal_view;
int colpal_type;
int colpal_windx;
int colpal_windy;
int colpal_icon = -1;
int colpal_tick;
int colpal_tintstatus;

int colpal_horiz;
int colpal_w;			// icon block size
int colpal_h;
int colpal_yspace;		// gap between first 2 rows
int colpal_xlimit;		// left edge of col name icon
int colpal_min = 6;
int colpal_max = 30;


int cop_tag=('c'<<24)|('o'<<16)|('p'<<8);



// read horiz/vert choices

void colpal_readchoices(void)
{
 if(tagexists(0,cop_tag,0))
 {
  colpal_horiz=tagread(0,cop_tag,0);
  colpal_palette=tagread(0,cop_tag,1);
  colpal_windx=tagread(0,cop_tag,2);
  colpal_windy=tagread(0,cop_tag,3);
  if(colpal_windx<=0 && colpal_windy<=0) colpal_centre=1;
 }
 else
 {
  colpal_horiz=1;
  colpal_centre=1;
  colpal_palette=1;
 }
}


// write horiz/vert choices

void colpal_quit(int user)
{

 if(colpal_centre==0)
 {
  tagwrite(0,cop_tag,colpal_horiz,0);
  tagwrite(0,cop_tag,colpal_palette,1);
  tagwrite(0,cop_tag,colpal_windx,2);
  tagwrite(0,cop_tag,colpal_windy,3);
 }
}




void colpal_updatepaldata(int file)
{
 string s;

 colpal_currnum=0;
 while(getcolour(colpal_currnum,s,colpal_file)) colpal_currnum++;
}




// given x, return column number

int colpal_column(int x,int orgx)
{
 return((x - orgx - 1) / colpal_w);
}


// given y, return row number

int colpal_row(int y,int orgy)
{
 return((orgy - y - 1 -colpal_yspace) / colpal_h);
}


// given r and c, return icon number

int colpal_geticon(int r, int c)
{
 int i;

 if(!colpal_horiz)
  i = (r - 1) * colpal_min + c;
 else
  i = (r - 1) * colpal_max + c;

 if(i >= colpal_currnum) return(-1);
 return(i);
}


// given icon number, return x

int colpal_getx(int i)
{
 int c;

 if(!colpal_horiz)
  c = i % colpal_min;
 else
  c = i % colpal_max;

 return(colpal_w * c);
}


// given icon number, return y

int colpal_gety(int i)
{
 int r;

 if(!colpal_horiz)
  r = i / colpal_min + 1;
 else
  r = i / colpal_max + 1;

 return(-colpal_h * r - colpal_yspace);
}


// update colour name icon

void colpal_colname(int file)
{
 string s, t;
 int    code;

 getcolour(colpal_icon,s,file);

 code=read_slice_icon(colpal_handle,14,'s',t);
 if(code && t!=s)
 {
  writeicon(colpal_handle,14,s);
 }

 t=itos((getselectioncolour(colpal_type,1)*100+256)/0x10000);
 if(t!=readicon(colpal_handle,13))
 {
  writeicon(colpal_handle,13,t);
 }
}



// refresh colour rectangle

void colpal_refresh(int i)
{
 int x, y;

 x = colpal_getx(i);
 y = colpal_gety(i);
 refresh_area(0, colpal_handle, x, y - colpal_h, x + colpal_w, y);
}




void colpal_readcol(int file)
{
 int i, c, t;
 string s;

 i=colpal_icon;
 c=getselectioncolour(colpal_type,0);
 colpal_icon=0;
 while((t=getcolour(colpal_icon,s,file)))
 {
  if(t==c) break;
  colpal_icon++;
 }
 if(i!=colpal_icon)
 {
  colpal_refresh(i);
  colpal_refresh(colpal_icon);
 }
 colpal_colname(file);
}





// deal with clicks in Colour Palette window

void colpal_click(int handle,int icon,int bbits,int mx,int my)
{
 int i;
 string s;
 int    tempview;

 if(colpal_file)
 {
  tempview = currentview();
  setcurrentfile(colpal_file);

  if(icon==15) open_menu(colpal_thandle);
  else
  if(bbits==1 && icon==-1)
  {
   i=colpal_geticon(colpal_row(my,colpal_windy),colpal_column(mx,colpal_windx));
   if(i<0) i=0;
   openeditcolourbox(getcolour(i,s,colpal_file));
  }
  else 
  if(bbits==4 || bbits==1)
  {
   if(icon>=10 && icon<=12)
   { 
    colpal_type=(icon==12)?4:icon+1-10;
    select_icon(colpal_handle,10,colpal_type==1);
    select_icon(colpal_handle,11,colpal_type==2);
    select_icon(colpal_handle,12,colpal_type==4);

    colpal_readcol(colpal_file);
   }
   else
   if(colpal_type)
   {
    if(colpal_geticon(colpal_row(my,colpal_windy),colpal_column(mx,colpal_windx))!=-1)
    {
     i=colpal_icon;
     colpal_icon=colpal_geticon(colpal_row(my,colpal_windy),colpal_column(mx,colpal_windx));

     if(colpal_icon != i)
     {
      colpal_refresh(i);
      colpal_refresh(colpal_icon);
      colpal_colname(colpal_file);
     }
     i=stoi(readicon(colpal_handle,13))*0x10000/100;
     setselectioncolour(colpal_type,getcolour(colpal_icon,s,colpal_file),i,-1);
    }
   }
  }



  setcurrentview(tempview);
 }
}




int colpal_key(int handle, int icon, int key)
{
 int t;
 string s;

 t=stoi(readicon(colpal_handle,13));
 if(t>100)
 {
  t=100;
  writeicon(colpal_handle,13,itos(t));
 }

 setselectioncolour(colpal_type,getcolour(colpal_icon,s,colpal_file),t*0x10000/100,-1);

 return(key);
}



// close palette

void colpal_closewindow()
{
 close_window(colpal_handle);
 delete_window(colpal_handle);
 colpal_view=0;
 colpal_file=0;
 colpal_handle=0;
}




void colpal_closepalette(void)
{
 colpal_closewindow();
}




// handler for Colour palette close icon

void colpal_closepal(int handle)
{
 colpal_closepalette();
 colpal_palette=0;
}







void colpal_openwindowfn3(int h, int x0, int y0, int x1, int y1, int scx, int scy, int bh)
{
 int t, width, height;

 if(!colpal_centre)
 {
  x1+=(colpal_windx-x0);
  y0+=(colpal_windy-y1);
  x0=colpal_windx;
  y1=colpal_windy;
 }


 if(colpal_horiz)
 {
  width=colpal_currnum*colpal_w;
  if(colpal_currnum>=colpal_max)  width=colpal_max*colpal_w;
  if(colpal_currnum< 16)          width=16*colpal_w;
  height=(colpal_currnum-1)/colpal_max*colpal_h+2*colpal_h+colpal_yspace;

  if(colpal_centre)
  {
   y1=y1+((y0-y1)+height)/2;
   x0=x0+((x1-x0)-width)/2;
  }

  x1=x0+width;
  y0=y1-height;

 }
 else
 {
  width=colpal_min*colpal_w;
  height=((colpal_currnum-1)/colpal_min*colpal_h)+2*colpal_h+colpal_yspace;

  if(colpal_centre) y1=y1+((y0-y1)+(height))/2;

  x1=x0+width;
  y0=y1-height;
 }

 colpal_windx=x0;
 colpal_windy=y1;

 open_window(h,x0,y0,x1,y1,scx,scy,bh);
}



void colpal_openwindowfn5(int h, int x0, int y0, int x1, int y1, int scx, int scy, int bh)
{
 int          t;

 colpal_windx=x0;
 colpal_windy=y1;


 t=colpal_horiz;
 if((x1-x0)>=colpal_xlimit && colpal_horiz==0)
 {
  colpal_horiz=1;
 }
 else
 if((x1-x0)<colpal_xlimit && colpal_horiz==1)
 {
  colpal_horiz=0;
 }

 if(colpal_horiz!=t) refresh_icon(0,colpal_handle,-1);
}


void colpal_plot(int p, int x, int y)
{
 bbc_plot(p, x, y);
}


void colpal_redraw(int h, int x0, int x1, int y0, int y1, int scx, int scy, int gx0, int gx1, int gy0, int gy1)
{
 int r, c, i, x, y, p;


 for(r = colpal_row(gy1,y1); r <= colpal_row(gy0,y1); ++r)
 {
  for(c = colpal_column(gx0,x0); c <= colpal_column(gx1,x0); ++c)
  {
   if((i=colpal_geticon(r,c))<0) continue;

   p=getcolourpal(i,0x10000,0,colpal_file);
   x=colpal_getx(i);
   y=colpal_gety(i);


   if(p==-1)
   {
    plot_icon(colpal_handle,x,y-colpal_h,x+colpal_w,y,0,"\\C\\V\\F\\k-1\\acolpal_trans","abx");
   }
   else
   {
    bbc_gcol(p,0);
    colpal_plot(8+4,x0+x,y1-colpal_h+y);
    colpal_plot(0x61,(7*colpal_w)/8,(7*colpal_h)/8);
   }

   if(i==colpal_icon) plot_icon(colpal_handle,x,y-colpal_h,x+colpal_w,y,0,"\\F\\k-1\\E0\\s","abx");
  }
 }
}




// if state == 1 shade icon, otherwise unshade

void colpal_shadeicon(int icon, int state)
{
 set_icon_state(colpal_handle, icon, (1 << 22) * state, (1 << 22));
}




// set state of buttons on info palette

void colpal_setbuttons(int s0, int s1, int s2, int s3, int t)
{
 colpal_shadeicon(10,s0);
 colpal_shadeicon(11,s1);
 colpal_shadeicon(12,s2);
 if(s3!=colpal_tintstatus) colpal_shadeicon(13,s3);
 select_icon(colpal_handle,10,t==1);
 select_icon(colpal_handle,11,t==2);
 select_icon(colpal_handle,12,t==4);

 colpal_type=t;
 colpal_tintstatus=s3;
}




void colpal_openwindow(int view)
{
 colpal_handle=create_windowparent("colpal_main",viewhandle(view));
 setwindowflags(colpal_handle,8,8);
 addwindowhandler(0,colpal_handle,"colpal_click");
 addwindowhandler(1,colpal_handle,"colpal_key");
 addwindowhandler(2,colpal_handle,"colpal_closepal");
 addwindowhandler(3,colpal_handle,"colpal_openwindowfn3");
 addwindowhandler(4,colpal_handle,"colpal_redraw");
 addwindowhandler(5,colpal_handle,"colpal_openwindowfn5");

 colpal_w=geticon(colpal_handle,10,2)-geticon(colpal_handle,10,0);
 colpal_h=geticon(colpal_handle,10,3)-geticon(colpal_handle,10,1);
 colpal_yspace=-2*geticon(colpal_handle,10,3);
 colpal_xlimit=geticon(colpal_handle,14,0);

 colpal_view=view;
 colpal_file=filefromview(view);
}



void colpal_updatepalette(int file)
{
 int tempview, i;

 if(file && colpal_palette && colpal_handle)
 {
  tempview=currentview();
  setcurrentfile(file);

  if(activetype(TEXTFRAME))  colpal_setbuttons(0, 0, 0, 0, 1);
  else
  if(activetype(PICTFRAME))  colpal_setbuttons(0, 0, 1, 0, 1);
  else
  if(activetype(0x1004))     colpal_setbuttons(0, 0, 1, 0, 2);
  else
  {
   colpal_setbuttons(1,1,1,1,0);
   i=colpal_icon;
   colpal_icon=-1;
   colpal_refresh(i);
   colpal_colname(file);
  }

  colpal_readcol(file);

  setcurrentview(tempview);
 }
}





void colpal_openpalette(int view)
{
 if(view)
 {
  colpal_openwindow(view);
  colpal_updatepaldata(colpal_file);
  colpal_updatepalette(colpal_file);
  display_window(colpal_handle,0,colpal_centre);
  colpal_centre=0;
 }
}





// update palette whenever the colours are edited

void colpal_colsedited(int user, int file)
{
 if(colpal_palette && colpal_handle && file==colpal_file)
 {
  colpal_updatepaldata(file);
  refresh_icon(0,colpal_handle,-1);
 }
}






void colpal_objectselect(int user, int file, int object)
{
 colpal_updatepalette(file);
}


void colpal_objectmodify(int user, int file)
{
 colpal_updatepalette(file);
}


void colpal_textupdate(int user, int file)
{
 int tempview;

 if(file && colpal_palette && colpal_handle)
 {
  tempview = currentview();
  setcurrentfile(file);

  if(activetype(TEXTFRAME) && zoneorder()) colpal_setbuttons(0,0,0,0,4);

  colpal_readcol(file);
 
  setcurrentview(tempview);
 }
}




void colpal_activeview(int user,int view,int gain)
{

 if(gain && colpal_palette && view && view!=colpal_view)
 {
  colpal_openpalette(view);
 }

 if(!gain && colpal_palette && view && view==colpal_view && colpal_handle)
 {
  colpal_closewindow();
 }

}



// open/close colour palette

int colpal_entry(int entry, int subcode)
{
 colpal_palette=!colpal_palette;
 if(colpal_palette)	colpal_openpalette(activeview());
 else               colpal_closepalette();
 return(0);
}


// tick or un-tick 'Colour palette' menu entry

int colpal_flags(int entry, string &text)
{
 return(colpal_palette);
}






int colpal_tentry(int entry, int subcode)
{
 int t;
 string s;

 t = stoi(string_menu(colpal_thandle, entry));
 writeicon(colpal_handle, 13, itos(t));
 setselectioncolour(colpal_type, getcolour(colpal_icon, s, colpal_file), t * 0x10000 / 100, -1);
 return(0);
}

int colpal_tflags(int entry,string & text)
{
 int t;

 t = stoi(readicon(colpal_handle, 13));

 switch(entry)
 {
  case  0:
          colpal_tick = 0;
  default:
          if(t == stoi(text)) return(colpal_tick = 1);
          break;
 }
 return(0);         
}



// add 'Colour palette' entry to 'Applets' menu

void main(void)
{
 int i;

 script_menu_initialise();


 script_menu_insert("colpal_entry","colpal_flags","","","{COLPAL_00}");

 addeventhandler(0x004, 0, "colpal_quit");

 addeventhandler(0x154, 0, "colpal_colsedited");   // defined colours have changed
 addeventhandler(0x00f, 0, "colpal_objectselect"); // object selected
 addeventhandler(0x011, 0, "colpal_objectselect"); // object deselected
 addeventhandler(0x01d, 0, "colpal_objectselect"); // object deleted
 addeventhandler(0x093, 0, "colpal_objectmodify"); // object modified
 addeventhandler(0x304, 0, "colpal_textupdate");   // text modified
 addeventhandler(0x215 ,0, "colpal_activeview");


 colpal_thandle=create_menu("{TNM00}");
 for(i = 10; i <= 100; i = i + 10)
 {
  addentry_menu(colpal_thandle,"colpal_tentry","colpal_tflags","","",itos(i));
 }

 colpal_readchoices();
}
