/*->c.xprocess */                                    



#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "font.h"
#include "wimp.h"
#include "flex.h"

#include "etc.h"

#include "bits.h"
#include "alloc.h"
#include "wos.h"
#include "transform.h"
#include "fsx.h"
#include "bf.h"
#include "poll.h"
#include "dbhi.h"
#include "xprocess.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "xcolour.h"
#include "xxcolour.h"


#include "file.h"
#include "view.h"
#include "object.h"
#include "undo.h"

#include "dscript.h"


#include "pxstr.h"
#include "pict.h"

#include "colsep.h"
#include "colseplink.h"


#include "csstr.h"
#include "colcode.h"

#include "csprocess.h"
#include "xpr.h"




#define UPROC    0x7400
#define UPSCREEN 0x7401






dbprocessstr defdbprocess=
{
 XPRGB,     /*  model RGB, HSV, CMYK */
 XPALL,     /*  mode  All, RGB etc.  */
 XPLIN,     /*  tool  linear, straight, curve */
 0,         /*  inverted */
 0,         /*  duotone  */
 OURBLACK,  /*  colourvalue  start */
 OURWHITE,  /*  colourvalue  end */
 1,         /*  update */
 0,         /*  use spots */

 0,0,0,0,   /*  brightness */
 0,0,0,0,   /*  contrast */
 0x10000,0x10000,0x10000,0x10000,   /*  gamma */

 2,2,2,2,   /*  gamman */

 0,0, CMAX,CMAX,  0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,

 0,0, CMAX,CMAX,  0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,

 0,0, CMAX,CMAX,  0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,

 0,0, CMAX,CMAX,  0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,
 0,0, 0,0,        0,0, 0,0,

};








void * processfindtag(processobjectstr * procp,int tagvalue)
{
 proctagstr * tag;
 proctagstr * limit;

 tag=(proctagstr*)(&procp->data.data[0]);
 limit=(proctagstr*)(((char*)&procp->data.data[0])+procp->data.len);

 while(tag<limit)
 {
  if(tag->tag==tagvalue) return(tag);
  tag=(proctagstr*)(((char*)tag)+tag->len);
 }

 return(NULL);
}





static os_error * processtagsize(int processkey,filestr * file,
                                                int type,int size) 
{
 processobjectstr * procp;
 proctagstr       * tag;
 int                delta;
 int                length;
 int                offset;
 int                taglen;

 size=(size+3)&(~0x3);

 procp=(processobjectstr*)fob_find(processkey,file);
 if(procp)
 {
  tag=(proctagstr*)processfindtag(procp,type);

  taglen=tag?tag->len:0;
  delta=(size-taglen);


  if(delta)
  {
   if(tag) offset=((char*)tag)-(char*)&procp->data.data[0];
   else    offset=procp->data.len;

   if(delta<0)
   {
    memmove(((char*)tag)+size,
           ((char*)tag)+taglen,procp->data.len-(offset+taglen));
   }

   length=procp->data.len+sizeof(processobjectstr)+sizeof(processdatastr);
   fob_change(processkey,file,length+delta,(fobjptr)&procp);

   tag=(proctagstr*)((char*)&procp->data.data[0]+offset);

   if(delta>0 && taglen)
   {
    memmove(((char*)tag)+size,
           ((char*)tag)+taglen,procp->data.len-(offset+taglen));
   }

   if(size)
   {
    tag->len=taglen+delta;
    tag->tag=type;
   }
  
   procp->data.len+=delta;
  }
 }

 return(NULL);
}





static os_error * processreadtag(proctagstr * dest,int type,
                                 int processkey,filestr * file)
{
 processobjectstr * procp;
 proctagstr       * tag;

 procp=(processobjectstr*)fob_find(processkey,file);
 if(procp)
 {
  tag=(proctagstr*)processfindtag(procp,type);

  XMEMCPYX(dest,tag,tag->len);
 }

 return(NULL);
}




static os_error * processwritetag(proctagstr * src,
                                  int processkey,filestr * file)
{
 processobjectstr * procp;
 proctagstr       * tag;


 processtagsize(processkey,file,src->tag,src->len);

 procp=(processobjectstr*)fob_find(processkey,file);
 if(procp)
 {
  tag=(proctagstr*)processfindtag(procp,src->tag);

  XMEMCPYX(tag,src,src->len);
 }

 return(NULL);
}







#define PROCUPDATE 0x1
#define PROCNOPROC 0x2
#define PROCREPROC 0x3
#define PROCNOTAG  0x4
#define PROCRETAG  0x5









os_error * deleteprocess(int processkey,filestr * file)
{
 if(processkey) return(fob_delete(processkey,file));
 else           return(NULL);
}





os_error * copyprocessm(int * dkey,filestr * dfile,
                        int skey,filestr * sfile,int mode)
{
 os_error         * err;
 processobjectstr * procp;
 processduostr      duo;
 processduostr    * duop;

 err=NULL;

 if(skey)
 {
  err=fob_copy((fobjptr)&procp,dfile,skey,sfile);
  if(!err)
  {
   *dkey=procp->key;
   if(sfile!=dfile)
   {
    duop=(processduostr*)processfindtag(procp,PROCDUOTAG);
    if(duop)
    {
     duo=*duop;
     mapcolour(sfile,dfile,&duo.start,mode);
     mapcolour(sfile,dfile,&duo.end,mode);
     fob_mod(*dkey,dfile,(fobjptr)&procp);
     duop=(processduostr*)processfindtag(procp,PROCDUOTAG);
     *duop=duo;
    }
   }
  }
 }

 if(!skey || err)
 {
  *dkey=0;
 }

 return(err);
}



/*****************************************************************************/



os_error * defltprocess(int * key,filestr * file)
{
 *key=0;
 return(NULL);
 USE(file);
}




int cmpprocess(int key1,filestr * file1,int key2,filestr * file2)
{

 return(0);

 USE(key1);
 USE(file1);
 USE(key2);
 USE(file2);
}







static os_error * getdbprocess(dbprocessstr * dbpr,int processkey,
                                       int * found,filestr * file)
{
 processhdrstr    * hdr;
 processduostr    * duo;
 processlinearstr * lin;
 processcurvestr  * cur;
 processobjectstr * procp;
 int                i;
 int                j;
 int                k;


 *found=0;
 procp=(processobjectstr*)fob_find(processkey,file);

 if(procp)
 {
  hdr=(processhdrstr*)processfindtag(procp,PROCHDRTAG);
  if(hdr)
  {
   dbpr->model=hdr->model;   /* RGB, HSV, CMYK */
   dbpr->mode=hdr->mode;     /* All, RGB etc.  */
   dbpr->tool=hdr->tool;     /* linear, straight, curve */
   dbpr->inverted=hdr->inverted;
   dbpr->update=hdr->update;
   dbpr->usespots=hdr->usespots;
  }

  duo=(processduostr*)processfindtag(procp,PROCDUOTAG);
  if(duo)
  {
   dbpr->duotone=duo->duotone;
   dbpr->start=duo->start;
   dbpr->end=duo->end;
  }

  lin=(processlinearstr*)processfindtag(procp,PROCLINTAG);
  if(lin)
  {
   for(i=0;i<4;i++)
   {
    dbpr->brightness[i]=lin->brightness[i];
    dbpr->contrast[i]=lin->contrast[i];
    dbpr->gamma[i]=lin->gamma[i];
   }
  }

  cur=(processcurvestr*)processfindtag(procp,PROCCURTAG);
  if(cur)
  {
   for(i=0;i<4;i++)
   {
    dbpr->gamman[i]=cur->gamman[i];
   }

   k=0;
   for(i=0;i<4;i++)
   {
    for(j=0;j<dbpr->gamman[i];j++)
    {
     dbpr->gammapoint[i][j]=cur->gammapoint[k++];
    }
   }

   *found=1;
  }
 }
 return(NULL);
}





os_error * getprocess(dbprocessstr * dbpr,int object,
                      int * oldprocess,int * found,filestr * file)
{
 os_error         * err;
 int                message;

 message=OM_GETPROCESS;
 *oldprocess=0;
 *found=0;
 err=objectmessage2(object,file,&message,oldprocess);
 if(!err)
 {
  if(*oldprocess) err=getdbprocess(dbpr,*oldprocess,found,file);
  if(!*oldprocess || !*found) *dbpr=defdbprocess;
 }

 return(err);
}





static void xpdb2hdr(processhdrstr * hdr,dbprocessstr * dbpr)
{
 hdr->tag=PROCHDRTAG;
 hdr->len=sizeof(processhdrstr);
 hdr->model=dbpr->model;   /* RGB, HSV, CMYK */
 hdr->mode=dbpr->mode;     /* All, RGB etc.  */
 hdr->tool=dbpr->tool;     /* linear, straight, curve */
 hdr->inverted=dbpr->inverted;
 hdr->update=dbpr->update;
 hdr->usespots=dbpr->usespots;
}



static void xpdb2duo(processduostr * duo,dbprocessstr * dbpr)
{
 duo->len=sizeof(processduostr);
 duo->tag=PROCDUOTAG;
 duo->duotone=dbpr->duotone;
 duo->start=dbpr->start;
 duo->end=dbpr->end;
}



static void xpdb2lin(processlinearstr * lin,dbprocessstr * dbpr)
{
 int i;

 for(i=0;i<4;i++)
 {
  lin->brightness[i]=dbpr->brightness[i];
  lin->contrast[i]=dbpr->contrast[i];
  lin->gamma[i]=dbpr->gamma[i];
 }

 lin->len=sizeof(processlinearstr);
 lin->tag=PROCLINTAG;
}



static void xpdb2cur(processcurvestr * cur,dbprocessstr * dbpr)
{
 int i;
 int j;
 int k;
 int n;

 n=0;

 for(i=0;i<4;i++)
 {
  n+=(cur->gamman[i]=dbpr->gamman[i]);
 }

 k=0;
 for(i=0;i<4;i++)
 {
  for(j=0;j<dbpr->gamman[i];j++)
  {
   cur->gammapoint[k++]=dbpr->gammapoint[i][j];
  }
 }

 cur->len=sizeof(processcurvestr)+((n-1)*sizeof(xpgpointstr));
 cur->tag=PROCCURTAG;
}






static int xcursize(dbprocessstr * dbpr)
{
 int n;
 int i;

 n=0;
 if(dbpr)
 {
  for(i=0;i<4;i++)
  {
   n+=dbpr->gamman[i];
  }
 }

 return(n);
}






static int cmphdr(dbprocessstr * dbpr1,dbprocessstr * dbpr2)
{
 return(
        (dbpr1->model!=dbpr2->model) ||
        (dbpr1->model!=dbpr2->mode)  ||
        (dbpr1->tool!=dbpr2->tool)   ||
        (dbpr1->inverted!=dbpr2->inverted) ||
        (dbpr1->update!=dbpr2->update)
       );
}




static int cmpduo(dbprocessstr * dbpr1,dbprocessstr * dbpr2)
{
 return(
        (dbpr1->duotone!=dbpr2->duotone) ||
        cmpcolourval(&dbpr1->start,&dbpr2->start) ||
        cmpcolourval(&dbpr1->end,&dbpr2->end)
       );
}



static int cmplin(dbprocessstr * dbpr1,dbprocessstr * dbpr2)
{
 int i;

 for(i=0;i<4;i++)
 {
  if(dbpr1->brightness[i]!=dbpr2->brightness[i]) return(1);
  if(dbpr1->contrast[i]!=dbpr2->contrast[i])     return(1);
  if(dbpr1->gamma[i]!=dbpr2->gamma[i])           return(1);
 }

 return(0);
}



static int cmpcur(dbprocessstr * dbpr1,dbprocessstr * dbpr2)
{
 int i;
 int j;

 for(i=0;i<4;i++)
 {
  if(dbpr1->gamman[i]!=dbpr2->gamman[i]) return(1);
 }

 for(i=0;i<4;i++)
 {
  for(j=0;j<dbpr1->gamman[i];j++)
  {
   if(dbpr1->gammapoint[i][j].x!=dbpr2->gammapoint[i][j].x) return(1);
   if(dbpr1->gammapoint[i][j].y!=dbpr2->gammapoint[i][j].y) return(1);
  }
 }

 return(0);
}





static os_error * writeprocess(processobjectstr * procp,dbprocessstr * dbpr)
{
 processhdrstr    * hdr;
 processduostr    * duo;
 processlinearstr * lin;
 processcurvestr  * cur;

 hdr=(processhdrstr*)processfindtag(procp,PROCHDRTAG);
 if(hdr) xpdb2hdr(hdr,dbpr);

 duo=(processduostr*)processfindtag(procp,PROCDUOTAG);
 if(duo) xpdb2duo(duo,dbpr);

 lin=(processlinearstr*)processfindtag(procp,PROCLINTAG);
 if(lin) xpdb2lin(lin,dbpr);

 cur=(processcurvestr*)processfindtag(procp,PROCCURTAG);
 if(cur) xpdb2cur(cur,dbpr);

 return(NULL);
}





static os_error * createprocess(int * processkey,
                                dbprocessstr * dbpr,int ns,filestr * file)
{
 os_error         * err;
 int                size;
 int                size2;
 int                n;
 int                csize;
 processobjectstr * procp;
 processhdrstr    * hdr;
 processduostr    * duo;
 processlinearstr * lin;
 processcurvestr  * cur;
 processscreenstr * scr;
 int                ssize;
 int                psize;


 n=xcursize(dbpr);
 csize=sizeof(processcurvestr)+((n-1)*sizeof(xpgpointstr));
 ssize=(ns>0)?(sizeof(processscreenstr)+((ns-1)*sizeof(colplatestr))):0;
 psize=(dbpr!=NULL)?(sizeof(processhdrstr)+sizeof(processduostr)+
                     sizeof(processlinearstr)+csize):0;

 size=sizeof(processobjectstr);
 size2=psize+ssize;
 size+=size2;

 err=fob_create(size,file,OPROCESS,(fobjptr)&procp);
 if(!err)
 {
  *processkey=procp->key;

  procp->data.len=size2;

  if(psize)
  {
   hdr=(processhdrstr*)(&procp->data.data[0]);
   hdr->len=sizeof(processhdrstr);
   hdr->tag=PROCHDRTAG;

   duo=(processduostr*)(((char*)hdr)+sizeof(processhdrstr));
   duo->len=sizeof(processduostr);
   duo->tag=PROCDUOTAG;

   lin=(processlinearstr*)(((char*)duo)+sizeof(processduostr));
   lin->len=sizeof(processlinearstr);
   lin->tag=PROCLINTAG;

   cur=(processcurvestr*)(((char*)lin)+sizeof(processlinearstr));
   cur->len=csize;
   cur->tag=PROCCURTAG;

   writeprocess(procp,dbpr);
  }

  if(ssize)
  {
   if(psize) scr=(processscreenstr*)(((char*)cur)+csize);
   else      scr=(processscreenstr*)(&procp->data.data[0]);

   scr->len=ssize;
   scr->tag=PROCSCRTAG;
  }
 }

 return(err);
}







#define PSIZE (sizeof(processcurvestr)+4*MAXGAMMAPOINT*sizeof(xpgpointstr))



/* tagged to UPROC */

static os_error * unprocpict(filestr * file)
{                
 os_error     * err;
 int            pict;
 int            command;
 int            processkey;
 char           stuff1[PSIZE];
 char           stuff2[PSIZE];
 int            message;
 int            type;


 err=NULL;

 undoread(file,&pict,sizeof(int));
 undowritefn(file,UPROC,&pict,sizeof(int));


 message=OM_GETPROCESS;
 processkey=0;
 err=objectmessage2(pict,file,&message,&processkey);



 undoread(file,&command,sizeof(int));
 if(command==PROCUPDATE)
 {
  undowrite(file,&command,sizeof(int));
  while(1)
  {
   undoread(file,stuff1,sizeof(proctagstr));

   if(((proctagstr*)stuff1)->tag==PROCNOMORE)
   {
    undowrite(file,stuff1,sizeof(proctagstr));
    break;
   }
   else
   {
    undoread(file,stuff1+sizeof(proctagstr),
                  ((proctagstr*)stuff1)->len-sizeof(proctagstr));

    processreadtag((proctagstr*)stuff2,((proctagstr*)stuff1)->tag,
                                                      processkey,file);

    processwritetag((proctagstr*)stuff1,processkey,file);

    undowrite(file,stuff2,sizeof(proctagstr));
    undowrite(file,stuff2+sizeof(proctagstr),
                   ((proctagstr*)stuff2)->len-sizeof(proctagstr));
   }
  }
 }
 else
 if(command==PROCNOPROC) /* i.e. there didn't used to be a process object */
 {
  command=PROCREPROC;
  undowrite(file,&command,sizeof(int));
  undowrite(file,&processkey,sizeof(int));
  message=OM_SETPROCESS;
  processkey=0;
  err=objectmessage2(pict,file,&message,(void*)processkey);
 }
 else
 if(command==PROCREPROC)
 {
  undoread(file,&processkey,sizeof(int));
  command=PROCNOPROC;
  undowrite(file,&command,sizeof(int));
  message=OM_SETPROCESS;
  err=objectmessage2(pict,file,&message,(void*)processkey);
 }
 else
 if(command==PROCNOTAG)
 {
  command=PROCRETAG;
  undowrite(file,&command,sizeof(int));
  while(1)
  {
   undoread(file,&type,sizeof(int));
   if(type==PROCNOMORE)
   {
    ((proctagstr*)stuff2)->tag=PROCNOMORE;
    ((proctagstr*)stuff2)->len=sizeof(proctagstr);
    undowrite(file,stuff2,sizeof(proctagstr));
    break;
   }
   else
   {
    processreadtag((proctagstr*)stuff2,type,processkey,file);
    undowrite(file,stuff2,sizeof(proctagstr));
    undowrite(file,stuff2+sizeof(proctagstr),
                   ((proctagstr*)stuff2)->len-sizeof(proctagstr));
   }
  }
 }
 else
 if(command==PROCRETAG)
 {
  command=PROCNOTAG;
  undowrite(file,&command,sizeof(int));
  while(1)
  {
   undoread(file,stuff1,sizeof(proctagstr));
   undowrite(file,&(((proctagstr*)stuff1)->tag),sizeof(int));
   if(((proctagstr*)stuff1)->tag==PROCNOMORE)
   {
    break;
   }
   else
   {
    undoread(file,stuff1+sizeof(proctagstr),
                  ((proctagstr*)stuff1)->len-sizeof(proctagstr));
    processwritetag((proctagstr*)stuff1,processkey,file);
   }
  }
 }


 pxrefresh(pict,0,0,file);

 return(err);
}



















os_error * applyprocess(dbprocessstr * dbpr,dbprocessstr * old,
                            int bits,int csection,int object,filestr * file)
{
 os_error         * err;
 int                message;
 int                processkey;
 processobjectstr * procp;
 int                n;
 int                command;
 char               stuff[PSIZE];
 int                csize;

 err=NULL;

 if((bits & PROCMOD)) err=modfile(file,csection);
 if(!err)
 {
  processkey=0;
  message=OM_GETPROCESS;
  err=objectmessage2(object,file,&message,&processkey);

  if(bits & PROCSCRAP)
  {
   /* if there is a process object, scrap it */
   if(processkey) err=fob_delete(processkey,file);

   processkey=0;

   message=OM_SETPROCESS;
   err=objectmessage2(object,file,&message,(void*)processkey);
  }
  else
  if(bits & PROCSCRAPTAG)
  {
            err=processtagsize(processkey,file,PROCCURTAG,0);
   if(!err) err=processtagsize(processkey,file,PROCHDRTAG,0);
   if(!err) err=processtagsize(processkey,file,PROCDUOTAG,0);
   if(!err) err=processtagsize(processkey,file,PROCLINTAG,0);
  }
  else
  {
   /* if there is no process object make one */
   if(!processkey)
   {
    err=createprocess(&processkey,dbpr,0,file);
   }
   else
   {
    n=xcursize(dbpr);
    csize=sizeof(processcurvestr)+((n-1)*sizeof(xpgpointstr));

       err=processtagsize(processkey,file,PROCCURTAG,csize);
    if(!err)
       err=processtagsize(processkey,file,PROCHDRTAG,sizeof(processhdrstr));
    if(!err)
       err=processtagsize(processkey,file,PROCDUOTAG,sizeof(processduostr));
    if(!err)
       err=processtagsize(processkey,file,PROCLINTAG,sizeof(processlinearstr));


    procp=(processobjectstr*)fob_find(processkey,file);

    /* update process object */
    if(!err && procp) writeprocess(procp,dbpr);
   }


   message=OM_SETPROCESS;
   err=objectmessage2(object,file,&message,(void*)processkey);

   if(!err)
   {
    if(bits & PROCUNDO)
    {
     err=undostart(file);
     if(!err)
     {
      undowritefn(file,UPROC,&object,sizeof(int));

      if(old)
      {
       command=PROCUPDATE;
       undowrite(file,&command,sizeof(int));

       if(cmphdr(old,dbpr))
       {
        xpdb2hdr((processhdrstr*)stuff,old);
        undowrite(file,stuff,sizeof(proctagstr));
        undowrite(file,stuff+sizeof(proctagstr),
                       sizeof(processhdrstr)-sizeof(proctagstr));
       }
   
       if(cmpduo(old,dbpr))
       {
        xpdb2duo((processduostr*)stuff,old);
        undowrite(file,stuff,sizeof(proctagstr));
        undowrite(file,stuff+sizeof(proctagstr),
                       sizeof(processduostr)-sizeof(proctagstr));
       }

       if(cmplin(old,dbpr))
       {
        xpdb2lin((processlinearstr*)stuff,old);
        undowrite(file,stuff,sizeof(proctagstr));
        undowrite(file,stuff+sizeof(proctagstr),
                       sizeof(processlinearstr)-sizeof(proctagstr));
       }

       if(cmpcur(old,dbpr))
       {
        xpdb2cur((processcurvestr*)stuff,old);
        undowrite(file,stuff,sizeof(proctagstr));
        undowrite(file,stuff+sizeof(proctagstr),
                       ((processcurvestr*)stuff)->len-sizeof(proctagstr));
       }

       ((proctagstr*)stuff)->tag=PROCNOMORE;
       ((proctagstr*)stuff)->len=sizeof(proctagstr);
       undowrite(file,stuff,sizeof(proctagstr));
      }
      else
      if(bits & PROCHADPROC)
      {
       command=PROCNOTAG;
       undowrite(file,&command,sizeof(int));
       command=PROCHDRTAG;
       undowrite(file,&command,sizeof(int));
       command=PROCDUOTAG;
       undowrite(file,&command,sizeof(int));
       command=PROCLINTAG;
       undowrite(file,&command,sizeof(int));
       command=PROCCURTAG;
       undowrite(file,&command,sizeof(int));
       command=PROCNOMORE;
       undowrite(file,&command,sizeof(int));
      }
      else
      {
       command=PROCNOPROC;
       undowrite(file,&command,sizeof(int));
      }

      undoend(file);
     }
    }
   }
  }
 }

 return(err);
}





/*****************************************************************************/





static os_error * prstatictag(void ** oldtag,int type,
                                             int processkey,filestr * file)
{
 os_error         * err;
 processobjectstr * procp;
 proctagstr       * tag;

 err=NULL;

 if(processkey)
 {
  procp=(processobjectstr*)fob_find(processkey,file);
  if(procp)
  {
   tag=(proctagstr*)processfindtag(procp,type);
   if(tag)
   {
    err=salloc(oldtag,tag->len);
    procp=(processobjectstr*)fob_find(processkey,file);
    tag=(proctagstr*)processfindtag(procp,type);
    XMEMCPYX(*oldtag,tag,tag->len);
   }
  }
 }

 return(err);
}



static os_error * prfreetag(void * oldtag)
{
 return(sfree(&oldtag));
}









/* tagged to UPSCREEN */

static os_error * unprocscreen(filestr * file)
{                
 os_error         * err;
 int                pict;
 int                command;
 int                processkey;
 int                message;
 proctagstr         tag;
 processscreenstr * oldtag;
 processscreenstr * newtag;


 err=NULL;


 undoread(file,&pict,sizeof(int));
 undowritefn(file,UPSCREEN,&pict,sizeof(int));


 message=OM_GETPROCESS;
 processkey=0;
 err=objectmessage2(pict,file,&message,&processkey);


 undoread(file,&command,sizeof(int));
 if(command==PROCUPDATE)
 {
  undowrite(file,&command,sizeof(int));
  while(1)
  {
   undoread(file,&tag,sizeof(proctagstr));

   if(tag.tag==PROCNOMORE)
   {
    undowrite(file,&tag,sizeof(proctagstr));
    break;
   }
   else
   {
    err=prstatictag((flex_ptr)&oldtag,PROCSCRTAG,processkey,file);
    if(!err)
    {
     err=salloc((flex_ptr)&newtag,tag.len);
     if(!err)
     {
      *((proctagstr*)newtag)=tag;
      undoread(file,&newtag->plates,newtag->len-sizeof(proctagstr));
      processwritetag((proctagstr*)newtag,processkey,file);
      sfree((flex_ptr)&oldtag);
     }

     undowrite(file,oldtag,sizeof(proctagstr));
     undowrite(file,&oldtag->plates,oldtag->len-sizeof(proctagstr)); 

     prfreetag(oldtag);
    }
   }
  }
 }
 else
 if(command==PROCNOPROC) /* i.e. there didn't used to be a process object */
 {
  command=PROCREPROC;
  undowrite(file,&command,sizeof(int));
  undowrite(file,&processkey,sizeof(int));
  message=OM_SETPROCESS;
  processkey=0;
  err=objectmessage2(pict,file,&message,(void*)processkey);
 }
 else
 if(command==PROCREPROC)
 {
  undoread(file,&processkey,sizeof(int));
  command=PROCNOPROC;
  undowrite(file,&command,sizeof(int));
  message=OM_SETPROCESS;
  err=objectmessage2(pict,file,&message,(void*)processkey);
 }
 else
 if(command==PROCNOTAG) /* there didn't used to be a scr tag */
 {
  err=prstatictag((flex_ptr)&oldtag,PROCSCRTAG,processkey,file);
  if(!err)
  {
   command=PROCRETAG;
   undowrite(file,&command,sizeof(int));
   undowrite(file,oldtag,sizeof(proctagstr));
   undowrite(file,&oldtag->plates,oldtag->len-sizeof(proctagstr));
   prfreetag(oldtag);
  }
  processtagsize(processkey,file,PROCSCRTAG,0); /* del tag */
 }
 else
 if(command==PROCRETAG) /* put back scr tag */
 {
  undoread(file,&tag,sizeof(proctagstr));
  err=salloc((flex_ptr)&oldtag,tag.len);
  if(!err)
  {
   *((proctagstr*)oldtag)=tag;
   undoread(file,&oldtag->plates,oldtag->len-sizeof(proctagstr));
   processwritetag((proctagstr*)oldtag,processkey,file);
   sfree((flex_ptr)&oldtag);
  }
  command=PROCNOTAG;
  undowrite(file,&command,sizeof(int));
 }

 return(err);
}





os_error * csmakescreen(int * processkey,filestr * file,
                                      int platesn,colplatestr ** platesp)
{
 os_error         * err;
 processobjectstr * procp;
 int                csize;
 int                size;
 processscreenstr * scr;


 csize=sizeof(processscreenstr)+((platesn-1)*sizeof(colplatestr));

 size=sizeof(processobjectstr)+csize;

 err=fob_create(size,file,OPROCESS,(fobjptr)&procp);
 if(!err)
 {
  *processkey=procp->key;

  procp->data.len=csize;

  scr=(processscreenstr*)(&procp->data.data[0]);
  scr->len=csize;
  scr->tag=PROCSCRTAG;
  scr->plates=platesn;
  XMEMCPYX(scr->plate,*platesp,platesn*sizeof(colplatestr));
 }

 return(err);
}











os_error * csapplyscreen(int cpictbox,int csection,filestr * file,
                                      int platesn,colplatestr ** platesp)
{
 os_error         * err;
 int                message;
 int                processkey;
 int                oldprocesskey;
 processobjectstr * procp;
 int                command;
 int                csize;
 int                size;
 processscreenstr * oldtag;
 int                change;
 proctagstr         tag;
 processscreenstr * scr;
 int                i;



 err=modfile(file,csection);
 if(!err)
 {
  oldtag=NULL;

  change=processkey=0;
  message=OM_GETPROCESS;
  err=objectmessage2(cpictbox,file,&message,&processkey);
  oldprocesskey=processkey;


  csize=sizeof(processscreenstr)+((platesn-1)*sizeof(colplatestr));

  if(processkey)
  {
   err=prstatictag((flex_ptr)&oldtag,PROCSCRTAG,processkey,file);
   if(oldtag)
   {
    change=(platesn!=oldtag->plates);
    if(!change)
    {
     for(i=0;i<platesn;i++)
     {
      change=oldtag->plate[i].spot!=(*platesp)[i].spot ||
             oldtag->plate[i].psscreen!=(*platesp)[i].psscreen ||
             oldtag->plate[i].angle!=(*platesp)[i].angle ||
             oldtag->plate[i].frequency!=(*platesp)[i].frequency ||
             oldtag->plate[i].colour!=(*platesp)[i].colour ||
             oldtag->plate[i].spotnumber!=(*platesp)[i].spotnumber;
      if(change) break;
     }
    }
   }
  }
  else
  {
   size=sizeof(processobjectstr)+csize;

   err=fob_create(size,file,OPROCESS,(fobjptr)&procp);
   if(!err)
   {
    processkey=procp->key;

    procp->data.len=csize;

    scr=(processscreenstr*)(&procp->data.data[0]);
    scr->len=csize;
    scr->tag=PROCSCRTAG;
   }
  }


  if(!err)
  {
   err=processtagsize(processkey,file,PROCSCRTAG,csize);
   procp=(processobjectstr*)fob_find(processkey,file);
   if(!err && procp)
   {
    scr=(processscreenstr*)processfindtag(procp,PROCSCRTAG);
    scr->plates=platesn;
    XMEMCPYX(scr->plate,*platesp,platesn*sizeof(colplatestr));
   }


   message=OM_SETPROCESS;
   err=objectmessage2(cpictbox,file,&message,(void*)processkey);

   if(!err)
   {
    err=undostart(file);
    if(!err)
    {
     undowritefn(file,UPSCREEN,&cpictbox,sizeof(int));

     if(oldprocesskey)
     {
      if(oldtag)
      {
       command=PROCUPDATE;
       undowrite(file,&command,sizeof(int));

       if(change)
       {
        undowrite(file,oldtag,sizeof(proctagstr));
        undowrite(file,((char*)oldtag)+sizeof(proctagstr),
                                       oldtag->len-sizeof(proctagstr));
       }

       tag.tag=PROCNOMORE;
       tag.len=sizeof(proctagstr);
       undowrite(file,&tag,sizeof(proctagstr));
      }
      else  /* didn't have tag before */
      {
       command=PROCNOTAG;
       undowrite(file,&command,sizeof(int));
      }
     }
     else
     {
      command=PROCNOPROC;
      undowrite(file,&command,sizeof(int));
     }

     undoend(file);
    }
   }
  }
  prfreetag(oldtag);
 }

 return(err);
}





os_error * csgetscreen2(int process,filestr * file,
                                    int * platesn,colplatestr ** platesp)
{
 os_error         * err;
 colsephdrstr       hdr;
 processobjectstr * procp;
 processscreenstr * scr;
 int                i;

 err=NULL;

 scr=NULL;

 if(process)
 {
  procp=(processobjectstr*)fob_find(process,file);
  if(procp) scr=(processscreenstr*)processfindtag(procp,PROCSCRTAG);
 }

 if(scr)
 {
  *platesn=scr->plates;

  err=flex_alloc((flex_ptr)platesp,scr->plates*sizeof(colplatestr));
  if(!err)
  {
   procp=(processobjectstr*)fob_find(process,file);
   scr=(processscreenstr*)processfindtag(procp,PROCSCRTAG);
   XMEMCPYX(*platesp,scr->plate,scr->plates*sizeof(colplatestr));
   cscheckplates(file,platesn,platesp);
  }
 }
 else
 {
  colgetsep(file,&hdr,platesp);
  *platesn=hdr.plates;
  for(i=0;i<*platesn;i++)
  {
   (*platesp)[i].psscreen=0;
  }
 }

 return(err);
}



os_error * csgetscreen(int cpictbox,filestr * file,
                                    int * platesn,colplatestr ** platesp)
{
 os_error         * err;
 int                message;
 int                oldprocess;

 message=OM_GETPROCESS;
 oldprocess=0;
          err=objectmessage2(cpictbox,file,&message,&oldprocess);
 if(!err) err=csgetscreen2(oldprocess,file,platesn,platesp);

 return(err);
}




/****************************************************************************/



#define DSTPRMODE           0x1501
#define DSTPRTOOL           0x1502
#define DSTPRINVERT         0x1503
#define DSTPRUPDATE         0x1504                         
#define DSTDUOTONE          0x1505
#define DSTPRPLANE          0x1506
#define DSTPRBRIGHTNESS     0x1507
#define DSTPRCONTRAST       0x1508
#define DSTGAMMA            0x1509
#define DSTGAMMAPOINT       0x150A
#define DSTPRMODEL          0x150B

#define DSTSCREEN           0x150C
#define DSTPLATE            0x150D
#define DSTPSSCREEN         0x150E
#define DSTFREQ             0x150F
#define DSTSPOTCOLOUR       0x1510
#define DSTDOT              0x1511
#define DSTPRUSESPOTS       0x1512








static os_error * duosub(dbprocessstr * dbpr,int * dsstack,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;
 int           n;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 n=0;

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case         DSTINT:
                       dbpr->duotone=ds->data.integer;
                       break;

   case DSTCOLOURVALUE:
                       if(n)
                       {
                        dbpr->end.data.tint.key=ds1->data.integer;
                        ds1=(dsobjectstr*)(dsstack+sp+2+3);
                        dbpr->end.data.tint.tint=ds1->data.integer;
                        if(nsp>(sp+2+6))
                        {
                         ds1=(dsobjectstr*)(dsstack+sp+2+6);
                         dbpr->end.data.tint.overprint=ds1->data.integer;
                        }
                       }
                       else
                       {
                        dbpr->start.data.tint.key=ds1->data.integer;
                        ds1=(dsobjectstr*)(dsstack+sp+2+3);
                        dbpr->start.data.tint.tint=ds1->data.integer;
                        if(nsp>(sp+2+6))
                        {
                         ds1=(dsobjectstr*)(dsstack+sp+2+6);
                         dbpr->start.data.tint.overprint=ds1->data.integer;
                        }
                       }
                       n++;
                       break;
  }

  sp=nsp;
 }

 return(NULL);
}




static os_error * planesub(dbprocessstr * dbpr,int * dsstack,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;
 int           plane;
 int           n;
 xpgpointstr   gammapoint[MAXGAMMAPOINT];


 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 plane=n=0;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {

   case DSTPRBRIGHTNESS:
                        dbpr->brightness[plane]=ds1->data.integer;
                        break;

   case   DSTPRCONTRAST:
                        dbpr->contrast[plane]=ds1->data.integer;
                        break;

   case        DSTGAMMA:
                        dbpr->gamma[plane]=ds1->data.integer;
                        break;

   case   DSTGAMMAPOINT:
                        gammapoint[n].x=ds1->data.integer;
                        ds1=(dsobjectstr*)(dsstack+sp+2+3);
                        gammapoint[n].y=ds1->data.integer;
                        n++;
                        break;

   case          DSTINT:
                        plane=ds->data.integer;
                        break;
  }
  sp=nsp;
 }

 if(n>0) 
 {
  XMEMCPYX(dbpr->gammapoint[plane],gammapoint,n*sizeof(xpgpointstr));
  dbpr->gamman[plane]=n;
 }

 return(NULL);
}







static os_error * platesub(colplatestr * platep,int * dsstack,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;


 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 memset(platep,0,sizeof(colplatestr));

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case   DSTPSSCREEN:
                      platep->psscreen=ds1->data.integer;
                      break;

   case       DSTFREQ:
                      platep->frequency=ds1->data.integer;
                      break;

   case DSTSPOTCOLOUR:
                      platep->spot=ds1->data.integer;
                      break;

   case        DSTDOT:
                      platep->spotnumber=ds1->data.integer;
                      break;

   case     DSTCOLOUR:
                      platep->colour=ds->data.integer;
                      break;

   case      DSTANGLE:
                      platep->angle=ds1->data.integer;
                      break;

  }
  sp=nsp;
 }

 return(NULL);
}



#define PLATECHUNK   (8*sizeof(colplatestr))


static os_error * screensub(colplatestr ** platep,int *np,int * dsstack,int sp)
{
 os_error    * err;
 dsobjectstr * ds;
 int           nsp;
 int           sl;
 colplatestr   plate;
 int           n;


 err=NULL;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 n=0;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);

  if(ds->type==DSTPLATE)
  {
   platesub(&plate,dsstack,sp);

   if(!*platep) err=flex_alloc((flex_ptr)platep,PLATECHUNK);
   else err=flex_chunk((flex_ptr)platep,(n+1)*sizeof(colplatestr),PLATECHUNK);
   if(err) break;

   (*platep)[n]=plate;

   n++;
  }

  sp=nsp;
 }

 *np=n;

 return(err);
}








static os_error * dsprocess(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 int               * dsstack;
 dbprocessstr        dbpr;
 int                 processkey;
 colplatestr       * platep;
 int                 n;
 int                 process;
 processobjectstr  * procp;
 processscreenstr  * scr;



 err=NULL;

 platep=NULL;
 n=0;
 process=0;

 dbpr=defdbprocess;


 sp=fp+2; /* skip leading type/len */

 dsstack=dsstackptr();

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);


  switch(ds->type)
  {
   case   DSTPRMODE:
                    process=1;
                    dbpr.mode=ds1->data.integer;
                    break;

   case  DSTPRMODEL:
                    dbpr.model=ds1->data.integer;
                    break;

   case   DSTPRTOOL:
                    dbpr.tool=ds1->data.integer;
                    break;

   case DSTPRINVERT:
                    dbpr.inverted=ds1->data.integer;
                    break;

   case DSTPRUPDATE:
                    dbpr.update=ds1->data.integer;
                    break;

   case DSTPRUSESPOTS:
                    dbpr.usespots=ds1->data.integer;
                    break;

   case  DSTDUOTONE:
                    duosub(&dbpr,dsstack,sp);
                    break;

   case  DSTPRPLANE:
                    planesub(&dbpr,dsstack,sp);
                    break;

   case   DSTSCREEN:
                    screensub(&platep,&n,dsstack,sp);
                    break;
  }
  sp=nsp;
 }



 createprocess(&processkey,process?(&dbpr):NULL,n,loc->file);

 if(n)
 {
  procp=(processobjectstr*)fob_find(processkey,loc->file);
  if(procp)
  {
   scr=(processscreenstr*)processfindtag(procp,PROCSCRTAG);
   scr->plates=n;
   XMEMCPYX(scr->plate,platep,n*sizeof(colplatestr));
  }
  flex_free((flex_ptr)&platep);
 }

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=processkey;
 ds->len=3*sizeof(int);

 return(err);
}







static int dsnulllist[]={
                          DSTENDLIST
                        };



static dscreator dsdefs[]=
{
 0,0,0,0, "process",         dsprocess,   0, DSTPROCESS,      dsnulllist,
 0,0,0,0, "processmode",     NULL,        0, DSTPRMODE,       dsnulllist,
 0,0,0,0, "processtool",     NULL,        0, DSTPRTOOL,       dsnulllist,
 0,0,0,0, "processinverted", NULL,        0, DSTPRINVERT,     dsnulllist,
 0,0,0,0, "processupdate",   NULL,        0, DSTPRUPDATE,     dsnulllist,
 0,0,0,0, "processusespots", NULL,        0, DSTPRUSESPOTS,   dsnulllist,
 0,0,0,0, "duotone",         NULL,        0, DSTDUOTONE,      dsnulllist,
 0,0,0,0, "plane",           NULL,        0, DSTPRPLANE,      dsnulllist,
 0,0,0,0, "brightness",      NULL,        0, DSTPRBRIGHTNESS, dsnulllist,
 0,0,0,0, "contrast",        NULL,        0, DSTPRCONTRAST,   dsnulllist,
 0,0,0,0, "gamma",           NULL,        0, DSTGAMMA,        dsnulllist,
 0,0,0,0, "gammapoint",      NULL,        0, DSTGAMMAPOINT,   dsnulllist,
 0,0,0,0, "processmodel",    NULL,        0, DSTPRMODEL,      dsnulllist,
 0,0,0,0, "screen",          NULL,        0, DSTSCREEN,       dsnulllist,
 0,0,0,0, "plate",           NULL,        0, DSTPLATE,        dsnulllist,
 0,0,0,0, "psscreen",        NULL,        0, DSTPSSCREEN,     dsnulllist,
 0,0,0,0, "frequency",       NULL,        0, DSTFREQ,         dsnulllist,
 0,0,0,0, "spotcolour",      NULL,        0, DSTSPOTCOLOUR,   dsnulllist,
 0,0,0,0, "dot",             NULL,        0, DSTDOT,          dsnulllist,
};






os_error * dswriteprocess(int processkey,buffer * bf,filestr * file)
{
 dbprocessstr       dbpr;
 int                i;
 int                j;
 int                found;
 processobjectstr * procp;
 processscreenstr * scr;


// cprintf("processkey %x",processkey);

 if(processkey)
 {
  getdbprocess(&dbpr,processkey,&found,file);

  bf_printf(bf,"\r\n{process ");

  if(found)
  {
   bf_printf(bf,"{processmodel %d}{processmode %d}{processtool %d}{processinverted %d}{processupdate %d}{processusespots %d}",dbpr.model,dbpr.mode,dbpr.tool,dbpr.inverted,dbpr.update,dbpr.usespots);

   bf_printf(bf,"\r\n{duotone %d {colourvalue COL_%02x 0x%x} {colourvalue COL_%02x 0x%x}}",dbpr.duotone,dbpr.start.data.tint.key,dbpr.start.data.tint.tint,
                    dbpr.end.data.tint.key,dbpr.end.data.tint.tint);

   for(i=0;i<4;i++)
   {
    bf_printf(bf,"\r\n{plane %d {brightness 0x%x} {contrast 0x%x} {gamma 0x%x}}",
                    i,dbpr.brightness[i],dbpr.contrast[i],dbpr.gamma[i]);
   }

   for(i=0;i<4;i++)
   {
    bf_printf(bf,"\r\n{plane %d ",i);
    for(j=0;j<dbpr.gamman[i];j++)
    {
     bf_printf(bf,"{gammapoint 0x%x 0x%x}",dbpr.gammapoint[i][j].x,
                                       dbpr.gammapoint[i][j].y);
    }
    bf_printf(bf,"}");
   }
  }


  procp=(processobjectstr*)fob_find(processkey,file);
  if(procp)
  {
   scr=(processscreenstr*)processfindtag(procp,PROCSCRTAG);
   if(scr)
   {
    bf_printf(bf,"\r\n{screen\r\n");

    for(i=0;i<scr->plates;i++)
    {
     bf_printfeol(bf,"{plate {psscreen %d} {angle 0x%x} {frequency 0x%x} COL_%02x {spotcolour %d} {dot %d}}",
                                    scr->plate[i].psscreen,
                                    scr->plate[i].angle,
                                    scr->plate[i].frequency,
                                    scr->plate[i].colour,
                                    scr->plate[i].spot,
                                    scr->plate[i].spotnumber);
    }

    bf_printfeol(bf,"}");
   }
  }
  bf_printfeol(bf,"}");
 }

 return(NULL);
}




/****************************************************************************/






#define UNDOS  2


static undofnstr undos[UNDOS]=
{
 unprocpict,            NULL, UPROC,      "{UPROC}",
 unprocscreen,          NULL, UPSCREEN,   "{UPSCR}",


};






static os_error * initevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_DOCINIT2,initevent,0);
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 return(undoaddblock(undos,UNDOS));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}




os_error * xprocessinit(void)
{
 return(addevent(EVENT_DOCINIT2,initevent,0));
}



