/*->h.xprocess */



#define XPRGB   0
#define XPHSV   1
#define XPCMYK  2

#define XPALL  -1

#define XPLIN   0
#define XPSTR   1
#define XPCUR   2



#define CMAX   0x8000



#define MAXBRI   0x10000
#define MINBRI  -0x10000
#define MAXCON   0x10000
#define MINCON  -0x10000
#define MAXGAM   0x10000
#define MINGAM  -0x10000





typedef struct xpgpointstr
{
 unsigned short int x;
 unsigned short int y;
} xpgpointstr;



#define MAXGAMMAPOINT 16


typedef struct dbprocessstr
{
 int          model;   /* RGB, HSV, CMYK */
 int          mode;    /* All, RGB etc.  */
 int          tool;    /* linear, straight, curve */
 int          inverted;
 int          duotone;
 colourvalue  start;
 colourvalue  end;
 int          update;
 int          usespots;
 int          brightness[4];
 int          contrast[4];
 int          gamma[4];

 int          gamman[4];
 xpgpointstr  gammapoint[4][MAXGAMMAPOINT];

 int          spare[4];

} dbprocessstr;



extern dbprocessstr defdbprocess;


extern os_error * setprocess(int key,viewstr * view,processstr * pr);
extern os_error * deleteprocess(int processkey,filestr * file);
extern os_error * copyprocessm(int * dkey,filestr * dfile,
                               int skey,filestr * sfile,int mode);

extern os_error * dswriteprocess(int processkey,buffer * bf,filestr * file);
extern os_error * defltprocess(int * key,filestr * file);
extern int        cmpprocess(int key1,filestr * file1,
                             int key2,filestr * file2);








typedef struct processdatastr
{
 int len;
 int data[1];

} processdatastr;



typedef struct processobjectstr
{
 int             key;
 int             type;

 chainstr        chain;

 processdatastr  data;

} processobjectstr;



typedef struct proctagstr
{
 int          len;
 int          tag;
} proctagstr;



#define PROCHDRTAG 0x1

typedef struct processhdrstr
{
 int          len;
 int          tag;
 int          model;   /* RGB, HSV, CMYK */
 int          mode;    /* All, RGB etc.  */
 int          tool;    /* linear, straight, curve */
 int          inverted;
 unsigned int update:1;
 unsigned int usespots:1;
} processhdrstr;



#define PROCDUOTAG 0x2

typedef struct processduostr
{
 int          len;
 int          tag;
 int          duotone;
 colourvalue  start;
 colourvalue  end;
} processduostr;


#define PROCLINTAG 0x3


typedef struct processlinearstr
{
 int          len;
 int          tag;
 int          brightness[4];
 int          contrast[4];
 int          gamma[4];
} processlinearstr;



#define PROCCURTAG 0x4


typedef struct processcurvestr
{
 int          len;
 int          tag;
 int          gamman[4];
 xpgpointstr  gammapoint[1];

} processcurvestr;


#define PROCNOMORE 0x5




#define PROCSCRTAG 0x6


typedef struct processscreenstr
{
 int          len;
 int          tag;
 int          plates;
 colplatestr  plate[1];

} processscreenstr;





extern os_error * getprocess(dbprocessstr * dbpr,int object,
                             int * oldprocess,int * found,filestr * file);



#define PROCSCRAP    0x1
#define PROCUNDO     0x2
#define PROCMOD      0x4
#define PROCHADPROC  0x8
#define PROCSCRAPTAG 0x10



extern os_error * applyprocess(dbprocessstr * xnew,dbprocessstr * old,
                            int bits,int csection,int object,filestr * file);


extern void makegammapath(int * path,int n,xpgpointstr * p,int line);


extern os_error * xprocessinit(void);



extern os_error * csapplyscreen(int cpictbox,int csection,filestr * file,
                                      int platesn,colplatestr ** platesp);

extern os_error * csgetscreen(int cpictbox,filestr * file,
                                    int * platesn,colplatestr ** platesp2);


extern os_error * csgetscreen2(int process,filestr * file,
                                    int * platesn,colplatestr ** platesp);

extern os_error * csmakescreen(int * processkey,filestr * file,
                                      int platesn,colplatestr ** platesp);


