/*->c.dbcolsep */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "trans.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"




#include "str.h"
#include "constants.h"
#include "object.h"

#include "units.h"
#include "view.h"
#include "file.h"
#include "dbscale.h"
#include "select.h"

#include "xcolour.h"
#include "xxcolour.h"


#include "pxstr.h"
#include "pict.h"
#include "pixtool.h"

#include "dbprint.h"


#include "colsep.h"
#include "colseplink.h"




#include "colsepx.h"
#include "csstr.h"


#include "csprocess.h"
#include "colcode.h"
#include "cscurve.h"
#include "csink.h"
#include "cschoice.h"

#include "dbcolsep.h"




static viewstr * cview;
static filestr * cfile;
static int       cpictbox;
static int       csection;

static closescreenfn closescreen;


extern dboxstr       colsepbox;


extern dboxstr       screenbox[2];


static int           platefreq;
static int           plateangle;
static int           psscreen;
static int           spotnumber;

static int           selectedplaten;
static int           focusn;

static colplatestr * platesp;
static colplatestr * platesp2;
static int           platesn;


static int           docolseps;
static int           doseptext;


static char          septext[SEPTEXTLEN];


/****************************************************************************/



#define PANETOPMARGIN  8
#define PANESTEP       32
#define PANEHEIGHT     28
#define PANETEXTSHIFT  0
#define PANELEFTMARGIN 4
#define PANETEXT       36*16







static os_error * setplatesextent(int handle)
{
 os_error * err;
 windowstr  window;
 int        height;
 int        width;

 err=getw(handle,&window);
 if(!err)
 {
  width=window.x1-window.x0;
  height=MAX(window.y1-window.y0,PANETOPMARGIN+platesn*PANESTEP);
  err=extent(handle,0,-height,width,0);
 }
 return(err);
}





static os_error * platesredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error  * err;
 int         ox;
 int         oy;
 int         ylo;
 int         yhi;
 int         n;
 int         y;
 colourstr * cs;
 char        string[64];


 err=NULL;

	if(more)
	{
  wimpfontstart(0);

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

   n=(ylo-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   y=n*PANESTEP+PANETOPMARGIN;


   while(y<=yhi && n<platesn)
   {
    wimp_setcolour(n==selectedplaten?WIMPBLACK:WIMPWHITE);
    bbc_rectanglefilli(ox+PANELEFTMARGIN,oy-y,PANETEXT,-PANEHEIGHT);

    if(n==focusn)
    {
     wimp_setcolour(WIMPWHITE);
     wimp_setcolour(0xF0+WIMPBLACK);
     bbc_setstyle(1);
     bbc_rectanglei(ox+PANELEFTMARGIN,oy-y,PANETEXT,-PANEHEIGHT);
    }

    findcoloursp(platesp2[n].colour,&cs,cfile);

    xsprintf(sizeof(string),NULL,string,"%s: %d lpi, %d%c",cs->name,platesp2[n].frequency,
                                              platesp2[n].angle/0x10000,176);

    stringat(ox+PANELEFTMARGIN,oy-y-PANETEXTSHIFT,
             string,
             n==selectedplaten?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);

    y+=PANESTEP;
    n++;
   }

   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}

 return(err);

 USE(handle);
}




static os_error * platesredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) platesredrawsub(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}




static void platesrefreshline(int handle,int n)
{
 wimp_redrawstr  r;
 int             more;
 vdustr        * cvdu;


 cvdu=getcvdu();

 r.box.x0=PANELEFTMARGIN-cvdu->extrax;
 r.box.x1=r.box.x0+PANETEXT+2*cvdu->extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu->extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu->extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 platesredrawsub(handle,&r,more);
}




static os_error * newselectedn(int n)
{
 os_error * err;

 plateangle=-platesp2[n].angle;
 err=dbchangevalue(&plateangle,screenbox);

 return(err);
}



static os_error * oldselectedn(int n)
{
 os_error * err;

 err=dbreadvalues(screenbox);
 platesp2[n].angle=-plateangle;

 return(err);
}


static os_error * paneselectn(int handle,int n)
{
 os_error * err;
 int        oldn;

 oldn=selectedplaten;
 oldselectedn(selectedplaten);
 selectedplaten=n;
 if(focusn>=0) focusn=selectedplaten;
 platesrefreshline(handle,oldn);
 platesrefreshline(handle,selectedplaten);
 err=newselectedn(n);
 setfocus(handle);

 return(err);
}


static os_error * paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 return(wimp_open_wind(&wblock.o));
}




static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 int        oldfocusn;

 err=NULL;

// cprintf("gain %d",gain);

 if(gain)
 {
  focusn=selectedplaten;
  platesrefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  platesrefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}



static os_error * panekey(int panehandle,int userhandle,int icon,int * key)
{
 int ch;
 int n;
 int next;
 int mainhandle;


 ch=*key;

 mainhandle=screenbox[0].handle;

 if(ch==CUP || ch==CDOWN)
 {
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=platesn) n=platesn-1;

  if(n!=selectedplaten)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }


 return(NULL);

 USE(userhandle);
 USE(icon);
}







static os_error * platesicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=getw(handle,&window);
 if(!err)
 {
  n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;

  paneselectn(handle,n);
 }

 return(err);

 USE(userhandle);
}







static os_error * screenclose(int code)
{
 os_error    * err;
 int           i;
 int           processkey;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  for(i=0;i<platesn;i++)
  {
   platesp2[i].frequency=platefreq;
   platesp2[i].psscreen=psscreen;
   platesp2[i].spotnumber=spotnumber;
  }

  if(closescreen)
  {
   err=csmakescreen(&processkey,cfile,platesn,&platesp2);
   if(!err) err=closescreen(processkey,code);
  }
  else
  if(cpictbox)
  {
   err=csapplyscreen(cpictbox,csection,cfile,platesn,&platesp2);
  }
  else
  {
   XMEMCPYX(platesp,platesp2,platesn*sizeof(colplatestr));
  }
 }

 if(!err && code!=DBAPPLY)
 {
  flex_free((flex_ptr)&platesp2);
  remcaretevent(panecaret,screenbox[1].handle,0);
 }

	if(!err && code==DBAPPLY)
	{
		refreshwindow(screenbox[1].handle);

	}

 return(err);
}







static os_error * screenicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==6) err=openmenuparent("csspot_menu",handle);

 return(err);

 USE(handle);
 USE(userhandle);
}


int csgetspot(int fp)
{
 return(spotnumber);
 USE(fp);
}


void cssetspot(int fp)
{
 int * stack;

 stack=xstackptr();
 spotnumber=stack[fp];
 dbchangevalue(&spotnumber,screenbox);
}



static os_error * wrspot(int value,char * string)
{
 int result;
 int bits;
 *string=0;
 return(xexec("csspotname",&result,"IS/RVS",value,string,&bits,string));
}



static os_error * wrfreq(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}



static os_error * rdfreq(int * value,char * string)
{
 return(stringtonumber(string,value));
}





static dbiconstr screenicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    7, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0,     NULL ,0,
   12, &platefreq,   DBWRITE,  0,   0,      -1,-1,-1,-1,     rdfreq,wrfreq,
    9, &plateangle,  DBWRITE,  0,   0,      -1,-1,-1,-1, readangle,writeangle,
   13, &psscreen,    DBTOGGLE, 0,   0,       1,F1, 0, 0,         NULL, 0,
    5, &spotnumber,  DBTEXT,   0,   0,      -1,-1,-1,-1,         NULL,wrspot,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr screenbox[2]=
{
 0,
 TSCREEN,
 DBFIX,
 0,
 screenclose,
 screenicon,
 NULL,
 NULL,
 screenicondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TPLATES,
 DBPANE,
 0,
 NULL,
 platesicon,
 panekey,
 platesredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,
};




static os_error * dbscreens(dboxstr * parent)
{
 os_error     * err;

 selectedplaten=0;
 focusn=-1;
 platefreq=platesp2[0].frequency;
 plateangle=-platesp2[selectedplaten].angle;
 psscreen=platesp2[0].psscreen;
 spotnumber=platesp2[0].spotnumber;

 err=dodboxsp(screenbox,2,parent,getviewstack());
 if(err)
 {
  flex_free((flex_ptr)&platesp2);
 }
 else
 {
  wimp_setwindowbackground(screenbox[1].handle,CCRGB+PALWHITE);
  err=setplatesextent(screenbox[1].handle);
  if(!err) err=addcaretevent(panecaret,screenbox[1].handle,0);
  if(!err) err=wimp_setwindowflags(screenbox[1].handle,WINDOWNOTDIALOGUE,0);
 }

 return(err);
}




static os_error * dbscreen(void)
{
 os_error     * err;

 dbclear(screenbox);

 cpictbox=0;
 closescreen=NULL;

 err=flex_alloc((flex_ptr)&platesp2,platesn*sizeof(colplatestr));
 if(!err)
 {
  XMEMCPYX(platesp2,platesp,platesn*sizeof(colplatestr));
  err=dbscreens(&colsepbox);
 }

 return(err);
}




os_error * csopenscreen(int process,filestr * file,dboxstr * parent,
                                                   closescreenfn csfn)
{
 os_error * err;

 dbclear(screenbox);

 closescreen=csfn;
 cpictbox=0;
 cfile=file;

 err=csgetscreen2(process,cfile,&platesn,&platesp2);
 if(!err) err=dbscreens(parent);

 return(err);
}





/* script function opens the screen dialogue box for a picture */

void openscreenbox(int fp)
{
 os_error      * err;


 err=dbclear(screenbox);
	if(!err)
	{
  cview=getmenuview();
  cfile=cview->file;;
  closescreen=NULL;

  err=pixselected(&cpictbox,cfile);
  if(!err)
  {
   getselection(NULL,&csection,NULL,NULL);
   err=csgetscreen(cpictbox,cfile,&platesn,&platesp2);
   if(!err) err=dbscreens(screenbox);
		}
 }

 zreport(err);
}




/*****************************************************************************/


static os_error * writeplates(void)
{
 int               i;
 int               ns;
 int               nsx;
 int               n;
 int               nx;
 char            * p;
 colourstr       * cs;


 n=ns=nx=nsx=0;

 for(i=0;i<platesn;i++)
 {
  if(platesp[i].spot) ns++;

  if(platesp[i].print)
  {
   n++;
   nx=i;
   if(platesp[i].spot) nsx++;
  }
 }

 if(n==0) p="None";
 else
 if(n==1)
 {
  findcoloursp(platesp[nx].colour,&cs,cfile);
  p=cs->name;
 }
 else
 if(n==platesn) p="All plates";
 else
 if(n==ns && n==nsx) p="All spots";
 else
/* if(n>1) */ p="Selection";


 writeiconc(colsepbox.handle,5,p);

 return(NULL);
}




static os_error * colsepicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  6:  /* screen */
          err=dbscreen();
          break;  

  case  3:
          err=openmenuparent("csplate_menu",handle);
          break;

 }

 return(err);

 USE(handle);
 USE(userhandle);
}








static os_error * wrtext(int value,char * string)
{
 strcpy(string,septext);
 return(NULL);
 USE(value);
}


static os_error * rdtext(int * value,char * string)
{
 xzstrncpy(septext,string,sizeof(septext));
 return(NULL);
 USE(value);
}




static os_error * colsepclose(int code)
{
 os_error        * err;
 colsephdrstr      hdr;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  colgetsep(cfile,&hdr,NULL);

  hdr.doseparations=docolseps;
  hdr.doseptext=doseptext;
  xzstrncpy(hdr.septext,septext,sizeof(hdr.septext));
  hdr.plates=platesn;

  err=colputsep(cfile,&hdr,&platesp);
 }

 if(!err && code!=DBAPPLY) flex_free((flex_ptr)&platesp);

 return(err);
}



static os_error * docs(int handle,int userhandle,wimp_mousestr * m)
{
 if(docolseps) return(dbprintfix(1,1));
 else          return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}








static dbiconstr colsepicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

    0, &docolseps,   DBTOGGLE, 0,   0,      1,F1, 0, 0, (dbreadfn)docs,0,
    7, &doseptext,   DBTOGGLE, 0,   0,      1,F2, 0, 0,          NULL ,0,
    8, NULL,         DBWRITE,  0,   0,      -1,-1,-1,-1,   rdtext,wrtext,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr colsepbox=
{
 0,
 TSEPARATIONS,
 DBFIX,
 0,
 colsepclose,
 colsepicon,
 NULL,
 NULL,
 colsepicondefs,
 0,
 0,
 1,NULL,
 0,
 0,
};



static char * csmodelname[]=
{
 "{CS00}", // Separations (No correction)
 "{CS01}", // Separations (
 "{CS02}",  // Separations (
 "{CS03}",  // Separations (
 "{CS04}",  // Separations (
};

#define CSMODELNAMESIZE (sizeof(csmodelname)/sizeof(char*))


os_error * colsepopen(viewstr * view,dboxstr * dbox)
{
 os_error        * err;
 colsephdrstr      hdr;
 char              buffer[256];

 cview=view;
 cfile=view->file;

 buffer[0]=0;
 if(csprintercolourmodel>=0 && csprintercolourmodel<CSMODELNAMESIZE)
 {
  strcpy(buffer,csmodelname[csprintercolourmodel]);
 }
 if(csprintercolourmodel==CSINKMODEL)
 {
  strcat(buffer,cscinkname());
  strcat(buffer,")");
 }
 else
 if(csprintercolourmodel==CSCURVEMODEL)
 {
  strcat(buffer,csccurvename());
  strcat(buffer,")");
 }
 else
 if(csprintercolourmodel==CSPRINTERPROFILE)
 {
  strcat(buffer,csprinterprofilename());
  strcat(buffer,")");
 }
 else
 if(csscreencolourmodel==CSSCREENPROFILE)
 {
  strcat(buffer,csscreenprofilename());
  strcat(buffer,")");
 }


 trans(buffer,sizeof(buffer));


 err=colgetsep(cfile,&hdr,&platesp);
 if(!err)
 {
  platesn=hdr.plates;
  docolseps=hdr.doseparations;
  doseptext=hdr.doseptext;
  xzstrncpy(septext,hdr.septext,sizeof(septext));


  err=dodboxsp(&colsepbox,1,dbox,getviewstack());
  if(err)
  {
   flex_free((flex_ptr)&platesp);
  }
  else
  {
   writetitle(colsepbox.handle,buffer);

   writeplates();
  }
 }

 return(err);
}





/* int csplatebits(int n,int spot,int bic,int eor) */

int csplatebits(int fp)
{
 int             * stack;
 int               n;
 int               spot;
 int               bits;
 int               i;
 int               bic;
 int               eor;


 stack=xstackptr();

 n=stack[fp];
 spot=stack[fp+1];
 bic=stack[fp+2];
 eor=stack[fp+3];


 if(platesp)
 {
  for(i=0;i<platesn;i++)
  {
   if(platesp[i].spot==(unsigned)spot)
   {
    n--;
    if(n<0)
    {
     bits=(platesp[i].print<<1);
     bits&=(~bic);
     bits^=eor;
     platesp[i].print=bits>>1;

     if(bic || eor) writeplates();

     return(bits);
    }
   }
  }
 }

 return(0);
}






/* int csplatename(int n,string & s,int spot) */


int csplatename(int fp)
{
 int             * stack;
 int               n;
 int               spot;
 char              temp[256];
 colourstr       * cs;
 int               i;
 int               s;


 stack=xstackptr();

 n=stack[fp];
 s=stack[fp+1];
 spot=stack[fp+2];

 if(platesp)
 {
  for(i=0;i<platesn;i++)
  {
   if(platesp[i].spot==(unsigned)spot)
   {
    n--;
    if(n<0)
    {
     findcoloursp(platesp[i].colour,&cs,cfile);
     xzstrncpy(temp,cs->name,sizeof(temp));
     assignstring(s,temp);
     return(1);
    }
   }
  }
 }

 return(0);
}





/* int csviewname(int n,string & s,int spot) */


int csviewname(int fp)
{
 int             * stack;
 int               n;
 int               spot;
 char              temp[256];
 colourstr       * cs;
 int               i;
 int               s;
 filestr         * csfile;
 colsepobjectstr * csp;


 stack=xstackptr();

 csfile=getmenuview()->file;
 n=stack[fp];
 s=stack[fp+1];
 spot=stack[fp+2];


 if(!csfile->hdr.colsep) colsepinit(csfile);

 if(csfile->hdr.colsep)
 {
  csp=(colsepobjectstr*)fob_find(csfile->hdr.colsep,csfile);

  for(i=0;i<csp->data.hdr.plates;i++)
  {
   if(csp->data.plate[i].spot==(unsigned)spot)
   {
    n--;
    if(n<0)
    {
     findcoloursp(csp->data.plate[i].colour,&cs,csfile);
     xzstrncpy(temp,cs->name,sizeof(temp));
     assignstring(s,temp);
     return(1);
    }
   }
  }
 }

 return(0);
}





