/*->c.fillobject */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"
#include "avl.h"
#include "colour.h"
#include "xmath.h"
#include "deb.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"



#include "object.h"
#include "select.h"
#include "xredraw.h"
#include "curve.h"
#include "splib.h"
#include "geometry.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"
#include "xrender.h"

#include "prstr.h"
#include "xprint.h"





#include "filllink.h"



#include "filltool.h"
#include "dbfill.h"
#include "fill.h"


#include "fillobject.h"




/*****************************************************************************/



static os_error * getfilltransform(transformstr * filltr,curvestr * c,
                     transformstr * ctr,filestr * file,int fill,int * process)
{
 filldatastr     data;
 fillobjectstr * fb;
 transformstr    tr1;
 transformstr    tr2;
 transformstr    tr;
 transformstr    boxtr;
 boxbitstr       bf;
 transformstr    rx;
 coordstr        cx;
 int             xscale;
 int             yscale;


 fb=(fillobjectstr*)fob_find(fill,file);
 data=fb->data;
 *process=data.process;

 tr_setidentity(&tr); /* assume fill is in y+ve going down, ourunits frame */

 yscale=data.scale;
 xscale=ttmul(yscale,data.aspect);
 tr_setscale(&tr2,0x10000,xscale,0x10000,yscale);
 tr_multiply(&tr1,&tr,&tr2);

 tr_setidentity(&tr2);
 tr_setskew(&tr2,data.skew);
 tr=tr1;
 tr_multiply(&tr1,&tr,&tr2);

 getboxbits(&c->box,ctr,&bf);

 tr_setidentity(&tr2);
 tr_setrotationa(&tr2,bf.angle+data.angle);

 tr_multiply(&tr,&tr1,&tr2);

 tr_setidentity(&rx);
 tr_setrotationa(&rx,bf.angle);
 cx.x=data.x;
 cx.y=data.y;
 tr_transformset(&cx,1,&rx);

 tr_setshift(&boxtr,bf.orgx+cx.x,bf.orgy+cx.y);

 tr_multiply(filltr,&tr,&boxtr);

 return(NULL);
}

static void orderbox(aboxstr * box)
{
 if(box->x0>box->x1) SWOP(box->x0,box->x1);
 if(box->y0>box->y1) SWOP(box->y0,box->y1);
}




static os_error * rendersub(fillblockstr  * fillp,viewredrawstr * v,
                            curvestr * c,curvestylestr * cstyle,
                            transformstr * tr)
{
 os_error        * err;
 transformstr      restr2;
 transformstr      filltr;
 transformstr      tr1;
 transformstr      tr2;
 transformstr      tr3;
 transformstr      etr;
 transformstr      drtr;
 coordstr          cx1;
 coordstr          cx2;
 boxstr            maxbox;
 int               gx0;
 int               gy0;
 int               gx1;
 int               gy1;
 int               rgx0;
 int               rgy0;
 int               rgx1;
 int               rgy1;
 aboxstr           abox;
// aboxstr           abox2;
 int               cliplevel;
 int               memory;
 vdustr            svdu;
 vdustr          * cvdu;
 int               action;
 int               spflags;
// int               transparent;
 int               xscale;
 int               yscale;
 int               prxres;
 int               pryres;
 int               prbpp;
 int               pxxres;
 int               pxyres;
 int               pxbpp;
 int               gsflag;
// int               claim;
 int               dorenderfill;
 int               process;
 void            * cliphandle;
 int               visible;

/*#ifdef NEVER */
 int               rendermemory;
/*#endif */

 viewstr         * view;
 filestr         * file;

/* int               time=clock(); */



 err=NULL;

 view=v->view;
 file=v->file;

 cvdu=getcvdu();

 etr=*tr;

 getfilltransform(&filltr,c,&etr,file,cstyle->fill.fill,&process);

 getmaxbox(&maxbox,&c->box,&etr);

 action=cstyle->pstyle.action;

 if(c->type!=CBOX) cliplevel=2;
 else
 {
  if(tr->b || tr->c) cliplevel=2;
  else               cliplevel=1;
 }


// aim here is that rectangular clip box covers same area as
// Draw style filled area used for frame background.

 getdrtr(&drtr,NULL,v);
 cx1.x=maxbox.x;
 cx1.y=maxbox.y;
 cx2.x=maxbox.x+maxbox.w;
 cx2.y=maxbox.y+maxbox.h;
 tr_transformset(&cx1,1,&drtr);
 tr_transformset(&cx2,1,&drtr);

//    cprintf("gx0 %d gy0 %d gx1 %d gy1 %d",gx0*256,gy0*256,gx1*256,gy1*256);
//    cprintf("cx0 %d cy0 %d cx1 %d cy1 %d",cx1.x,cx1.y,cx2.x,cx2.y);

 gx0=cx1.x;
 gx1=cx2.x;
 gy0=cx2.y;
 gy1=cx1.y;

  /* gx0... is biggest area covered by the picture in draw space */

 rgx0=v->redrawstr.g.x0*256;
 rgx1=v->redrawstr.g.x1*256;
 rgy0=v->redrawstr.g.y0*256;
 rgy1=v->redrawstr.g.y1*256;


 /* gx0... is biggest area covered by the curve in os space */

 if(
    (!((gx1<rgx0) || (rgx0>rgx1) || (gy1<rgy0) || (gy0>rgy1))) && (action & 0x2)
   )
 {
  if(rgx0>gx0) abox.x0=rgx0;
  else         abox.x0=gx0;

  if(rgx1<gx1) abox.x1=rgx1;
  else         abox.x1=gx1;

  if(rgy0>gy0) abox.y0=rgy0;
  else         abox.y0=gy0;

  if(rgy1<gy1) abox.y1=rgy1;
  else         abox.y1=gy1;

  /* abox is biggest area of picture to plot in os space */





  if((abox.x0<(abox.x1)) && (abox.y0<(abox.y1)))
  {
   render_gwinrectdr(abox.x0,abox.y0,abox.x1,abox.y1,&visible,v);
   if(visible)
   {
    colseparationpict(v,0,process,CSPX_START);

    if(cliplevel>0  || v->isprinter)
    {
     render_saveclippath(&cliphandle,v);
    }

    if(cliplevel>1 || v->isprinter) /* now always try to use this code */
    {                               /* for more precision */
     render_setclipcurve(c,tr,v);     
    }
    else
    if(cliplevel==1)
    {
     render_gwindowdr(abox.x0,abox.y0,abox.x1,abox.y1,v);
    }


    if(v->isprinter) event(EVENT_PRPXSTART,view,(int)v);
				if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))	event(EVENT_PSSTARTPICT,view,(int)v);



//   getdrtr(&restr2,&filltr,v);
    tr_multiply(&restr2,&filltr,&drtr);

    abox.x0/=256;
    abox.x1/=256;
    abox.y0/=256;
    abox.y1/=256;


    dorenderfill=1;

    if(fillp->renderd)
    {
     err=fillp->renderd(&abox,&restr2,&filltr,v,c,cstyle,&etr,&dorenderfill);
    }


    if(dorenderfill)
    {
     if(/*cliplevel>1 ||*/ (fillp->flags & FLF_BUFFER))
     {
      tr_transformset((coordstr*)&abox,2,&v->tr);
      orderbox(&abox);
      tr_multiply(&restr2,&restr2,&v->tr);

      memory=flex_freemem();

  /*  rendermemory=imrendermem(picturep,&restr2,&pr,v); */

      rendermemory=0x80000;
  
      if(rendermemory>memory/2) memory/=2;
      else                      memory-=rendermemory;

      svdu=*cvdu;

//      vsetcolour(&cstyle->fillcolour,&transparent,view);
//      err=render_setcolour(&cstyle->fillcolour,&transparent,v);

//      transparent=(vfindcolour(view,&cstyle->fillcolour)==-1);


      if(!v->isprinter)
      {

//       if(fillp->flags & FLF_SOLID) spflags=0;
//       else
//       {  /* if bckgrnd transparent */
//        spflags=transparent?SP_BACKFILL:0;
//       }

//      /* if(cliplevel<2) */ spflags|=SP_NOMASK;


       spflags=SP_NOMASK;

       abox.x1+=cvdu->extrax;       // fiddle ensures that render area
       abox.y0-=cvdu->extray;       // is bigger than clip area

       err=sp_renderstart((wimp_box*)&abox,SP_PALETTE|spflags,memory,
                cvdu->xdpi,cvdu->ydpi,1<<cvdu->ln2bpp,0x10000,0x10000);
      }
      else
      {
       /* first calculate printer xres,yres,bpp  */

       prxres=((prjobstr*)v->prjob)->xres;
       pryres=((prjobstr*)v->prjob)->yres;
       if((((prjobstr*)v->prjob)->bits & PRCOLOUR) || (!(getprintbits() & PRB_GREY)))
       {
        gsflag=0;
        prbpp=32;
/*
       if(ISOS35) prbpp=32;
       else       prbpp=8;
*/
       }
       else
       {
        gsflag=1;
        prbpp=8;
       }
     
//       if((fillp->flags & FLF_SOLID) || !transparent)
//       {
//        spflags=0;
//      /*  if(cliplevel<2) */spflags|=SP_NOMASK;
//       }
//       else
//       {
//        spflags=SP_DFILL;
//       }

       spflags=SP_NOMASK;


    /* second calculate picture xres,yres,bpp */

       pxxres=0;
       pxyres=0;
       pxbpp=0;

     /* then calculate min of the above        */

       prxres=MAX(prxres,pryres);
       pxxres=MAX(pxxres,pxyres);
  
     /* x values now used */

       if(pxxres==0) pxxres=prxres;
       else          pxxres=MIN(prxres,pxxres);

       if(pxbpp==0)  pxbpp=prbpp;
       else          pxbpp=MIN(pxbpp,prbpp);

     /* pxx values are now what we want */

       prxres=180/cvdu->deltax;
       pryres=180/cvdu->deltay;

       xscale=scale(0x10000,pxxres,prxres);
       yscale=scale(0x10000,pxxres,pryres);


       abox.y0-=cvdu->extray;
       abox.y1+=cvdu->extray;


       abox.x1=abox.x0+ttmul(xscale,abox.x1-abox.x0);
       abox.y1=abox.y0+ttmul(yscale,abox.y1-abox.y0);


       tr_setscalepoint(&tr2,xscale,yscale,abox.x0*256,abox.y0*256);
       tr3=restr2;
       tr_multiply(&restr2,&tr3,&tr2);

       tr_setscalepoint(&tr2,xscale,yscale,ourunits(abox.x0-v->ox,view)-v->xpo,
                                           ourunits(v->oy-abox.y0,view)-v->ypo);
      
       tr3=etr;
       tr_multiply(&etr,&tr3,&tr2); 

       tr3=filltr;
       tr_multiply(&filltr,&tr3,&tr2);


       err=sp_renderstart((wimp_box*)&abox,SP_PALETTE|spflags|
                (gsflag?SP_GREY:0)|((getprintbits() & PRB_INV56)?SP_INV56:0),
                 memory,cvdu->xdpi,cvdu->ydpi,pxbpp,xscale,yscale);
      }

      if(!err)
      {
       while(sp_rendergetbox((wimp_box*)&abox))
       {
        sp_rendersprite(&svdu);
        redrawswitch(0);
        startredraw();

        tr1=restr2;
        tr1.e-=abox.x0*256;
        tr1.f-=abox.y0*256;
        abox.x1-=abox.x0;
        abox.x0=0;
        abox.y1-=abox.y0;
        abox.y0=0;


        sp_pass(0);

//        if(!(fillp->flags & FLF_SOLID) && !transparent)
//        {
//         /* fill in background */
//         vsetcolour(&cstyle->fillcolour,&transparent,view);
//         sp_fill();
//        }

        err=fillp->render(&abox,&tr1,&filltr,v,c,cstyle,&etr);

//        if(!err)
//        {
//         if(spflags & SP_DFILL) /* if filling background, don't get here */
//         {
//          sp_pass(1);

//          if(!(fillp->flags & FLF_SOLID) && !transparent)
//          {
           /* fill in background */
//           vsetcolour(&cstyle->fillcolour,&transparent,view);
//           sp_fill();
//          }
//          err=fillp->render(&abox,&tr1,&filltr,v,c,cstyle,&etr);
//         }
//        }

        if(!err)
        {
         sp_pass(2);
         err=sp_renderpaint(&svdu);
        }
       }

       sp_renderend();

       startredraw();
      }
     }
     else
     {
      if(!(fillp->flags & FLF_SOLID)) /* fill in background */
      {
       if(action & 0x2)
       {
        cstyle->pstyle.action=0x2;
        err=rendercurve(v,c,cstyle,&etr);
       }
      }

      err=fillp->render(&abox,&restr2,&filltr,v,c,cstyle,&etr);
     }
    }

				if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))	event(EVENT_PSENDPICT,view,(int)v);
    if(v->isprinter) event(EVENT_PRPXEND,view,(int)v);

    if(cliplevel>1 || v->isprinter)
    {
     render_clearclipcurve(v);
    }

    if(cliplevel>0 || v->isprinter)
    {
     render_loadclippath(cliphandle,v);
    }

    colseparationpict(v,0,process,CSPX_END);
   }
  }
 }


 if(!err)
 {                                  /* render curve stuff */
  if(action & 0x1)
  {
   cstyle->pstyle.action=0x1;
   err=rendercurve(v,c,cstyle,tr);  /* nb back to real transform */
  }
 }

 cstyle->pstyle.action=action;


/* dprintf(0,"time=%d",clock()-time); */

 return(err);
}










static os_error * fillrender(viewredrawstr * v,curvestr * c,
                                    curvestylestr * cstyle,transformstr * t)

{
 os_error      * err;
 int             fill;
 fillobjectstr * fob;
 filestr       * file;
 int             filltype;
 fillblockstr  * fillp;

 file=v->file;

 fill=cstyle->fill.fill;

/* dprintf(0,"fillrender %d",fill); */

 if(fill)
 {
  fob=(fillobjectstr*)fob_find(fill,file);
  if(fob)
  {
   filltype=fob->filltype;
   fillp=findfillblock(filltype);

  /* dprintf(1,"filltype %d p=%x",filltype,fillp); */

   if(fillp)
   {
    if(fillp->frfn) err=fillp->frfn(v,c,cstyle,t);
    else            err=rendersub(fillp,v,c,cstyle,t);

   }
   else err=rendercurve(v,c,cstyle,t);
  }
  else err=rendercurve(v,c,cstyle,t);
 }
 else err=rendercurve(v,c,cstyle,t);

 return(NULL);
}



/****************************************************************************/

static os_error * filldelete(fillstr * fill,filestr * file)
{
 int             xfill;
 fillobjectstr * fb;
 fillblockstr  * fillp;
 int             filltype;

 xfill=fill->fill;
 if(xfill)
 {
  fb=(fillobjectstr*)fob_find(xfill,file);
  if(fb)
  {
   filltype=fb->filltype;
   fillp=findfillblock(filltype);
   if(fillp->fdfn) return(fillp->fdfn(fill,file));
   else
   {
    deleteprocess(fb->data.process,file);
    return(fob_delete(xfill,file));
   }
  }
 }

 return(NULL);
}



static os_error * fillcopy(fillstr * d,filestr * dfile,
                           fillstr * s,filestr * sfile,int mode)
{
 os_error      * err;
 fillobjectstr * fb;
 int             fill;
 fillblockstr  * fillp;
 int             filltype;


 fill=s->fill;

 if(fill)
 {
  fb=(fillobjectstr*)fob_find(fill,sfile);
  if(fb)
  {
   filltype=fb->filltype;
   fillp=findfillblock(filltype);
   if(fillp && fillp->fcfn) return(fillp->fcfn(d,dfile,s,sfile,mode));
   else
   {
    err=fob_copy((fobjptr)&fb,dfile,fill,sfile);
    if(!err) d->fill=fb->key;
    return(err);
   }
  }
 }

 d->fill=0;

 return(NULL);
}




static os_error * filldswrite(fillstr * fill,buffer * bf,filestr * file)
{
 int             xfill;
 fillobjectstr * fb;
 fillblockstr  * fillp;
 int             filltype;

 xfill=fill->fill;
 if(xfill)
 {
  fb=(fillobjectstr*)fob_find(xfill,file);
  if(fb)
  {
   filltype=fb->filltype;
   fillp=findfillblock(filltype);
   if(fillp->fsfn) return(fillp->fsfn(fill,bf,file));
  }
 }

 return(NULL);
}




static int fbcmpcs(void * key1,void * key2)
{
 return(*((int*)key1)-*((int*)key2));
}




fillblockstr * findfillblock(int filltype)
{
 fillblockstr * fillp;
 fillp=(fillblockstr*)avlfind(&filltype,(int)getfillroot(),NULL,fbcmpcs);
 if(fillp==(fillblockstr*)NIL_NODE) fillp=NULL;
 return(fillp);
}




os_error * fillobjectinit(void)
{

 return(fillregister(fillrender,fillcopy,filldelete,filldswrite));
}

